/* OpenCP Module Player
 * copyright (c) '94-'04 Niklas Beisert <nbeisert@physik.tu-muenchen.de>
 *
 * Try to init the LRMI library that is used by drivers like VESA
 *
 * revision history: (please note changes here)
 *  -ss040613   Stian Skjelstad <stian@nixia.no>
 *    -first release
 */

#include "config.h"
#include "pmain.h"
#include "lrmi.h"
#include "lrmi-ocp.h"

#include <stdio.h>
#include <sys/io.h>

int lrmi_is_available=0;

int ocp_lrmi_init(void)
{
  fprintf(stderr, "Initing LRMI... ");
  fflush(stderr);
  if (LRMI_init()!=1)
  {
    fprintf(stderr, "LRMI failed to init. BIOS/vm86 not available\n");
    return 0;
  } else {
    if (ioperm(0, 1024, 1))
    {
      perror("\nioperm()");
      return 0;
    } else {
      if (iopl(3))
      {
        perror("\niopl()");
        return 0;
      }
    }
  }
  fprintf(stderr, " compiled against version %s\n", LRMIVERSION);
  lrmi_is_available=1;
  return 0;
}

void ocp_lrmi_done(void)
{
}
