#ifndef __PMAIN_H
#define __PMAIN_H

#ifdef WIN32
#include "w32idata.h"
#endif

#define DEBUGSTRLEN 70
extern char debugstr[];
extern int debugint;

#ifdef DEBUG

#include "binfstd.h"

extern sbinfile debugfile;

#undef putc // undef the putc macro from stdio.h

#pragma warning 555 9 // disable warning about while(0) contruct

#define DEBUGSTR(a) \
do { \
  strcpy(debugstr, a); \
  writestr(debugfile, a); \
  debugfile.putc(10); \
} while(0)

#define DEBUGINT(a) \
do { \
  debugint=a; \
  char buf[80]; \
  sprintf(buf, "DEBUGINT: %i\n", debugint); \
  writestr(debugfile, buf); \
} while(0)
  
#else // DEBUG

#define DEBUGSTR(a)
#define DEBUGINT(a)

#endif // DEBUG

struct moduleinfostruct;

struct initcloseregstruct
{
  int (*Init)();
  void (*Close)();
  initcloseregstruct *next;
};

void plDosShell();
int plSystem(const char *);

void conInit();
void conSave();
void conRestore();

#if defined(DOS32) || (defined(WIN32)&&defined(NO_CPDLL_IMPORT))
extern int plScreenChanged;
#else
extern_data int plScreenChanged;
#endif

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
HINSTANCE win32GetHInstance();
#endif

extern const char *GetcfSoundSec();
extern const char *GetcfConfigSec();
extern const char *GetcfScreenSec();
extern const char *GetcfDataDir();
extern const char *GetcfCPPath();
extern const char *GetcfConfigDir();
extern const char *GetcfDataDir();
extern const char *GetcfProgramDir();
extern const char *GetcfTempDir();
extern const char *GetcfCommandLine();

int savebitrate(int br=-1);

#endif
